opssh 3.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154
  1. #!/bin/bash
  2. # vim: expandtab:tabstop=4:shiftwidth=4
  3. function usage() {
  4. cat << EOF
  5. Usage: opssh [OPTIONS] command [...]
  6. Options:
  7. --version show program's version number and exit
  8. --help show this help message and exit
  9. -l USER, --user=USER username (OPTIONAL)
  10. -p PAR, --par=PAR max number of parallel threads (OPTIONAL)
  11. --outdir=OUTDIR output directory for stdout files (OPTIONAL)
  12. --errdir=ERRDIR output directory for stderr files (OPTIONAL)
  13. -c CLUSTER, --cluster CLUSTER
  14. which cluster to use
  15. -e ENV, --env ENV which environment to use
  16. --v3 When working with v3 environments. v2 by default
  17. -t HOST_TYPE, --host-type HOST_TYPE
  18. which host type to use
  19. --list-host-types list all of the host types
  20. --timeout=TIMEOUT timeout (secs) (0 = no timeout) per host (OPTIONAL)
  21. -O OPTION, --option=OPTION
  22. SSH option (OPTIONAL)
  23. -v, --verbose turn on warning and diagnostic messages (OPTIONAL)
  24. -A, --askpass Ask for a password (OPTIONAL)
  25. -x ARGS, --extra-args=ARGS
  26. Extra command-line arguments, with processing for
  27. spaces, quotes, and backslashes
  28. -X ARG, --extra-arg=ARG
  29. Extra command-line argument
  30. -i, --inline inline aggregated output and error for each server
  31. --inline-stdout inline standard output for each server
  32. -I, --send-input read from standard input and send as input to ssh
  33. -P, --print print output as we get it
  34. Example: opssh -t ex-srv -e stg -l irb2 --outdir /tmp/foo uptime
  35. EOF
  36. }
  37. if [ $# -eq 0 ] || [ "$1" == "--help" ]
  38. then
  39. usage
  40. exit 1
  41. fi
  42. # See if ohi is installed
  43. if ! which ohi &>/dev/null ; then
  44. echo "ERROR: can't find ohi (OpenShift Host Inventory) on your system, please either install the openshift-ansible-bin package, or add openshift-ansible/bin to your path."
  45. exit 10
  46. fi
  47. PAR=200
  48. USER=root
  49. TIMEOUT=0
  50. ENV=""
  51. HOST_TYPE=""
  52. while [ $# -gt 0 ] ; do
  53. case $1 in
  54. -t|--host-type)
  55. shift # get past the option
  56. HOST_TYPE=$1
  57. shift # get past the value of the option
  58. ;;
  59. -c)
  60. shift # get past the option
  61. CLUSTER=$1
  62. shift # get past the value of the option
  63. ;;
  64. -e)
  65. shift # get past the option
  66. ENV=$1
  67. shift # get past the value of the option
  68. ;;
  69. --v3)
  70. OPENSHIFT_VERSION="--v3 --ip"
  71. shift # get past the value of the option
  72. ;;
  73. --timeout)
  74. shift # get past the option
  75. TIMEOUT=$1
  76. shift # get past the value of the option
  77. ;;
  78. -p|--par)
  79. shift # get past the option
  80. PAR=$1
  81. shift # get past the value of the option
  82. ;;
  83. -l|--user)
  84. shift # get past the option
  85. USER=$1
  86. shift # get past the value of the option
  87. ;;
  88. --list-host-types)
  89. ohi --list-host-types
  90. exit 0
  91. ;;
  92. -h|--hosts|-H|--host|-o)
  93. echo "ERROR: unknown option $1"
  94. exit 20
  95. ;;
  96. *)
  97. args+=("$1")
  98. shift
  99. ;;
  100. esac
  101. done
  102. # Get host list from ohi
  103. CMD=""
  104. if [ -n "$CLUSTER" ] ; then
  105. CMD="$CMD -c $CLUSTER"
  106. fi
  107. if [ -n "$ENV" ] ; then
  108. CMD="$CMD -e $ENV"
  109. fi
  110. if [ -n "$HOST_TYPE" ] ; then
  111. CMD="$CMD -t $HOST_TYPE"
  112. fi
  113. if [ -n "$OPENSHIFT_VERSION" ] ; then
  114. CMD="$CMD $OPENSHIFT_VERSION"
  115. fi
  116. if [ -n "$CMD" ] ; then
  117. HOSTS="$(ohi $CMD 2>/dev/null)"
  118. OHI_ECODE=$?
  119. fi
  120. if [ $OHI_ECODE -ne 0 ] ; then
  121. echo
  122. echo "ERROR: ohi failed with exit code $OHI_ECODE"
  123. echo
  124. echo "This is usually caused by a bad value passed for host-type or environment."
  125. echo
  126. exit 25
  127. fi
  128. exec pssh -t $TIMEOUT -p $PAR -l $USER -h <(echo "$HOSTS") "${args[@]}"